/*    12()    
         . */
#property copyright "Copyright 2015,  .."
#property link      "alextar@bk.ru"
//  
#property indicator_chart_window                   //    
#property indicator_buffers 4
#property strict
//  
#property indicator_color1 Green                   //  
#property indicator_width1 4
#property indicator_color2 Red                     //  
#property indicator_width2 4
#property indicator_color3 Red                     //  
#property indicator_width3 2
#property indicator_color4 Green                   //  
#property indicator_width4 2
// 
#define Zero                  0.00000001           //   
#define Infinity              100000000.0          // 
#define BottomSymbol          218                  //   
#define TopSymbol             217
#define UpSymbol              217
#define DownSymbol            218
#define ExcludeBBforExtremum  1                    //      
#define ExcludeBBforRecoil    0                    //        ?(1-,0-)
#define BottomRightWing       1                    //   
#define TopRightWing          1
#define UpRightWing           1
#define DownRightWing         1
#define UpLeftWing            1
#define DownLeftWing          1
#define StrictBottomLeftWing  false
#define StrictTopLeftWing     false
#define StrictUpLeftWing      false
#define StrictDownLeftWing    false
#define StrictBottomRightWing false
#define StrictTopRightWing    false
#define StrictUpRightWing     false
#define StrictDownRightWing   false
//  
int      LeftWing1     =0,
         RightWing2    =0;
datetime LastBottomTime=0,
         LastTopTime   =0;
double   LastBottom    =0,
         LastTop       =0,
         MaxPrice      =0,
         MinPrice      =Infinity;
//  
double Bottom[],Top[],                             // 
       Up[],    Down[];                            // 
//  
extern int BottomLeftWing=119,                     //     
           TopLeftWing   =119;                     //     
//+------------------------------------------------------------------+
int init(){
   ArraySetAsSeries(Bottom,true);                  //  
   SetIndexLabel(0,"Bottom");
   SetIndexBuffer(0,Bottom);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,BottomSymbol);
   SetIndexEmptyValue(0,0);
   ArraySetAsSeries(Top,true);
   SetIndexLabel(1,"Top");
   SetIndexBuffer(1,Top);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,TopSymbol);
   SetIndexEmptyValue(1,0);
   ArraySetAsSeries(Up,true);
   SetIndexLabel(2,"Up");
   SetIndexBuffer(2,Up);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,UpSymbol);
   SetIndexEmptyValue(2,0);
   ArraySetAsSeries(Down,true);
   SetIndexLabel(3,"Down");
   SetIndexBuffer(3,Down);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,DownSymbol);
   SetIndexEmptyValue(3,0);
   //   :
   LastBottomTime=0;
   LastTopTime   =0;
   LastBottom    =0;
   LastTop       =0;
   MaxPrice      =0;
   MinPrice      =Infinity;
   if( BottomLeftWing < TopLeftWing )
        LeftWing1=TopLeftWing;
   else LeftWing1=BottomLeftWing;
   if( DownRightWing > UpRightWing )
        RightWing2=DownRightWing;
   else RightWing2=UpRightWing;
   return(0);
}
//+------------------------------------------------------------------+
int start(){
   int i=0, j=0, LastBottomBar=0, LastTopBar=0,
       History=Bars-1, BarsLost=History-IndicatorCounted();
   if( BarsLost<History ){
      if( BarsLost<1 ) return(0);                  //    - 
      i=BarsLost+RightWing2;                       //   
   }
   else i=History-LeftWing1;                       //    
   if( LastBottomTime > 0 ) LastBottomBar=iBarShift(NULL,0,LastBottomTime);
   if( LastTopTime    > 0 ) LastTopBar   =iBarShift(NULL,0,LastTopTime);
   while( i > 0 ){                                 //   
      Bottom[i]=LFractal(i,BottomLeftWing,BottomRightWing,StrictBottomLeftWing,StrictBottomRightWing);
      if( Bottom[i] > Zero ){                      //   
         LastBottom   =Bottom[i];                  //   ,  
         LastBottomBar=i;                          //      
         MaxPrice     =High[i-ExcludeBBforExtremum];
      }
      if( LastBottomBar > 0 ){
         j=LastBottomBar-ExcludeBBforRecoil-UpLeftWing;
         while( j > UpRightWing ){                 //   
            if( LastBottom-Low[j] > Zero ){        //  
               LastBottom   =0;
               LastBottomBar=0;
               MaxPrice     =0;
               break;
            }
            if( High[j]-MaxPrice > Zero ) MaxPrice=High[j];
            Up[j]=HFractal(j,UpLeftWing,UpRightWing,StrictUpLeftWing,StrictUpRightWing);
            if( MaxPrice-Up[j] > Zero ) Up[j]=0;   //   
            if( Up[j] > Zero ){                    //  
               LastBottom   =0;                    //   
               LastBottomBar=0;
               MaxPrice     =0;
               break;
            }
            j--;
         }
      }
      Top[i]=HFractal(i,TopLeftWing,TopRightWing,StrictTopLeftWing,StrictTopRightWing);
      if( Top[i] > Zero ){                         //   
         LastTop   =Top[i];                        //   ,  
         LastTopBar=i;                             //      
         MinPrice  =Low[i-ExcludeBBforExtremum];
      }
      if( LastTopBar > 0 ){
         j=LastTopBar-ExcludeBBforRecoil-DownLeftWing;
         while( j > DownRightWing ){               //   
            if( High[j]-LastTop > Zero ){          //  
               LastTop   =0;
               LastTopBar=0;
               MinPrice  =Infinity;
               break;
            }
            if( MinPrice-Low[j] > Zero ) MinPrice=Low[j];
            Down[j]=LFractal(j,DownLeftWing,DownRightWing,StrictDownLeftWing,StrictDownRightWing);
            if( Down[j]-MinPrice > Zero ) Down[j]=0; //   
            if( Down[j] > Zero ){                  //  
               LastTop   =0;                       //   
               LastTopBar=0;
               MinPrice  =Infinity;
               break;
            }
            j--;
         }
      }
      i--;
   }
   if( LastBottomBar < 1 ) LastBottomTime=0;       //   
   else LastBottomTime=Time[LastBottomBar];
   if( LastTopBar < 1 )    LastTopTime   =0;
   else LastTopTime   =Time[LastTopBar];
   return(0);
}
//+------------------------------------------------------------------+
//   
double LFractal( int  i,                           //  
                 int  LeftWing,                    //   
                 int  RightWing,                   //   
                 bool StrictLeftWing,              //   
                 bool StrictRightWing ){           //   
   double C[],Result=0;
   if( i <= RightWing ) return(Result);
   int dim=ArrayResize(C,LeftWing+1+RightWing), j=0;
   while( j < dim ){                               //   
      C[j]=Low[j+i-RightWing];
      j++;
   }
   if( ( LeftWing                    < 1           //   , 
      || C[RightWing+1]-C[RightWing] > -Zero )     //       
    && ( RightWing                   < 1           //   , 
      || C[RightWing-1]-C[RightWing] > -Zero ) ){  //       
      Result=C[RightWing];                         //    
      j=1;
      while ( j < dim-1 ){
         if( ( j < RightWing                       //   ;     :
              && ( ( !StrictRightWing  && Result-C[j-1] > Zero )     // ( )
                || (  StrictRightWing  && C[j]  -C[j-1] > Zero ) ) ) // ( )
          || ( j > RightWing                       //   ;     :
              && ( ( !StrictLeftWing && Result-C[j+1] > Zero )         // ( )
                || (  StrictLeftWing && C[j]  -C[j+1] > Zero ) ) ) ) { // ( )
            Result=0;                              //    
            break;
         }
         j++;
      }
   }
   return(Result);
}
//+------------------------------------------------------------------+
//   
double HFractal( int  i,                           //  
                 int  LeftWing,                    //   
                 int  RightWing,                   //   
                 bool StrictLeftWing,              //   
                 bool StrictRightWing ){           //   
   double C[],Result=0;
   if( i <= RightWing ) return(Result);
   int dim=ArrayResize(C,LeftWing+1+RightWing), j=0;
   while( j < dim ){                               //   
      C[j]=High[j+i-RightWing];
      j++;
   }
   if( ( LeftWing                    < 1           //   , 
      || C[RightWing]-C[RightWing+1] > -Zero )     //       
    && ( RightWing                   < 1           //   , 
      || C[RightWing]-C[RightWing-1] > -Zero ) ){  //       
      Result=C[RightWing];                         //    
      j=1;
      while( j < dim-1 ){
         if( ( j < RightWing                       //   ;     :
              && ( ( !StrictRightWing  && C[j-1]-Result > Zero )     // ( )
                || (  StrictRightWing  && C[j-1]-C[j]   > Zero ) ) ) // ( )
          || ( j > RightWing                       //   ;     :
              && ( ( !StrictLeftWing && C[j+1]-Result > Zero )         // ( )
                || (  StrictLeftWing && C[j+1]-C[j]   > Zero ) ) ) ) { // ( )
            Result=0;                              //    
            break;
         }
         j++;
      }
   }
   return(Result);
}